%global version_major 6
%global version_minor 0
%global version_micro 0
%global serial 6
%global meadalpha %{nil}
%global meadrel %{nil}
%bcond_with bootstrap
%bcond_with maven_local
%bcond_with ivy_local

%{?scl:%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}^%{scl}-runtime$}
%{?scl:%scl_package javapackages-tools}
%{!?scl:%global pkg_name %{name}}

# Don't generate requires on jpackage-utils and java-headless for
# provided pseudo-artifacts: com.sun:tools and sun.jdk:jconsole.
%global __requires_exclude_from %{?__requires_exclude_from:%__requires_exclude_from|}/maven-metadata/javapackages-metadata.xml$

# Disable automatic bytecode compilation for files in java-utils
# https://fedoraproject.org/wiki/Packaging:Python_Appendix#Manual_byte_compilation
%global _python_bytecompile_extra 0

%global python_prefix python3
%global python_interpreter %{?__python3}%{!?__python3:dummy}
%global python_sitelib %{python3_sitelib}
# Turn off the brp-python-bytecompile script
%global __os_install_post %(echo '%{__os_install_post}' | sed -e /python-bytecompile/d)


%global default_jdk %{?_root_prefix}%{!?_root_prefix:%{_prefix}}/lib/jvm/java-17-openjdk
%global default_jre %{?_root_prefix}%{!?_root_prefix:%{_prefix}}/lib/jvm/jre-17-openjdk

Name:           %{?scl_prefix}javapackages-tools
Version:        6.0.0
Release:        %{serial}%{?dist}
Summary:        Macros and scripts for Java packaging support
License:        BSD
URL:            https://github.com/fedora-java/javapackages
BuildArch:      noarch

Source0:        https://github.com/fedora-java/javapackages/archive/%{version}.tar.gz
Patch0001:      0001-Move-python-modules-under-java-utils-directory.patch
Patch0002:      0002-jpackage-utils-scl.patch


%if 0
Source3:        javapackages-config.json

Source8:        toolchains-openjdk8.xml
Source11:       toolchains-openjdk11.xml
Source17:       toolchains-openjdk17.xml
%endif

BuildRequires:  coreutils
BuildRequires:  which
BuildRequires:  make
BuildRequires:  %{python_prefix}-devel
BuildRequires:  %{python_prefix}-lxml
BuildRequires:  %{python_prefix}-setuptools
%if !0%{?rhel}
BuildRequires:  %{python_prefix}-pytest
BuildRequires:  %{python_prefix}-pytest-cov
%endif

Requires:       %{?scl_prefix}javapackages-filesystem = %{version}-%{release}
Requires:       coreutils
Requires:       findutils
Requires:       which
%{?scl:Requires: %scl_runtime}

%if 0
# default JRE
Requires:       java-17-openjdk-headless
%endif

# These could be generated automatically, but then we would need to
# depend on javapackages-local for dependency generator.
Provides:       mvn(com.sun:tools) = SYSTEM
Provides:       mvn(sun.jdk:jconsole) = SYSTEM

%description
This package provides macros and scripts to support Java packaging.

%package -n %{?scl_prefix}javapackages-filesystem
Summary:        Java packages filesystem layout
Provides:       eclipse-filesystem = %{version}-%{release}

%description -n %{?scl_prefix}javapackages-filesystem
This package provides some basic directories into which Java packages
install their content.

%if %{with maven_local}
%package -n %{?scl_prefix}maven-local
Summary:        Macros and scripts for Maven packaging support
Requires:       %{?scl_prefix}%{name} = %{version}-%{release}
Requires:       %{?scl_prefix}javapackages-local = %{version}-%{release}
%if %{without bootstrap}
Requires:       %{_bindir}/xmvn
Requires:       mvn(org.fedoraproject.xmvn:xmvn-mojo)
# Common Maven plugins required by almost every build. It wouldn't make
# sense to explicitly require them in every package built with Maven.
Requires:       mvn(org.apache.maven.plugins:maven-compiler-plugin)
Requires:       mvn(org.apache.maven.plugins:maven-jar-plugin)
Requires:       mvn(org.apache.maven.plugins:maven-resources-plugin)
Requires:       mvn(org.apache.maven.plugins:maven-surefire-plugin)
%endif

%description -n %{?scl_prefix}maven-local
This package provides macros and scripts to support packaging Maven artifacts.
%endif

%if %{with ivy_local}
%package -n %{?scl_prefix}ivy-local
Summary:        Local mode for Apache Ivy
Requires:       %{name} = %{version}-%{release}
Requires:       %{?scl_prefix}javapackages-local = %{version}-%{release}
Requires:       apache-ivy >= 2.3.0-8
Requires:       xmvn-connector-ivy

%description -n %{?scl_prefix}ivy-local
This package implements local mode for Apache Ivy, which allows
artifact resolution using XMvn resolver.
%endif

%package -n %{?scl_prefix}%{python_prefix}-javapackages
Summary:        Module for handling various files for Java packaging
Requires:       %{python_prefix}-lxml
%{?scl:Requires: %scl_runtime}

%description -n %{?scl_prefix}%{python_prefix}-javapackages
Module for handling, querying and manipulating of various files for Java
packaging in Linux distributions

%package -n %{?scl_prefix}javapackages-local
Summary:        Non-essential macros and scripts for Java packaging support
Requires:       %{?scl_prefix}javapackages-generators = %{version}-%{release}
%if %{with bootstrap}
Requires:       %{?scl_prefix}javapackages-bootstrap
%else
Requires:       %{_bindir}/xmvn-install
Requires:       %{_bindir}/xmvn-subst
Requires:       %{_bindir}/xmvn-resolve
# Java build systems don't have hard requirement on java-devel, so it should be there
Requires:       java-17-openjdk-devel
%endif

%description -n %{?scl_prefix}javapackages-local
This package provides non-essential macros and scripts to support Java packaging.

%package -n %{?scl_prefix}javapackages-generators
Summary:        RPM dependency generators for Java packaging support
Requires:       %{?scl_prefix}%{name} = %{version}-%{release}
Requires:       %{?scl_prefix}%{python_prefix}-javapackages = %{version}-%{release}
Requires:       %{python_interpreter}

%description -n %{?scl_prefix}javapackages-generators
RPM dependency generators to support Java packaging.

%if %{with maven_local}
%package -n %{?scl_prefix}maven-local-openjdk8
Summary:        OpenJDK 8 toolchain for XMvn
RemovePathPostfixes: -openjdk8
Requires:       %{?scl_prefix}maven-local
Requires:       java-1.8.0-openjdk-devel

%description -n %{?scl_prefix}maven-local-openjdk8
OpenJDK 8 toolchain for XMvn

%package -n %{?scl_prefix}maven-local-openjdk11
Summary:        OpenJDK 11 toolchain for XMvn
RemovePathPostfixes: -openjdk11
Requires:       %{?scl_prefix}maven-local
Requires:       java-11-openjdk-devel

%description -n %{?scl_prefix}maven-local-openjdk11
OpenJDK 11 toolchain for XMvn

%package -n %{?scl_prefix}maven-local-openjdk17
Summary:        OpenJDK 17 toolchain for XMvn
RemovePathPostfixes: -openjdk17
Requires:       %{?scl_prefix}maven-local
Requires:       java-17-openjdk-devel

%description -n %{?scl_prefix}maven-local-openjdk17
OpenJDK 17 toolchain for XMvn
%endif

%prep
%setup -q -n javapackages-%{version}

sed -i '/^manpage /d' build
sed -i '/${mandir}/d' install

%patch0001 -p1
%patch0002 -p1

%build
%{?scl:scl enable %{scl} - << "EOF"}
%configure --pyinterpreter=%{python_interpreter} \
    --default_jdk=%{default_jdk} --default_jre=%{default_jre} \
    --rpmmacrodir=%{_scl_root}%{rpmmacrodir} \
    %{?scl:--rpmconfigdir=%{_root_prefix}/lib/rpm --scl=%{scl} --scl_root=%{_scl_root}}
./build

%install
%{?scl:scl enable %{scl} - << "EOF"}
./install

sed -e 's/.[17]$/&*/' -i files-*

#FIXME: broken on non-SCL
mv %{buildroot}%{_libdir}/rpm/macros.d/macros.fjava{,.%{?scl}}
mv %{buildroot}%{_libdir}/rpm/macros.d/macros.jpackage{,.%{?scl}}

sed -i 's:macros.\(fjava\|jpackage\|xmvn\):&.%{?scl}:' files-*

rm -rf %{buildroot}%{_bindir}/gradle-local
rm -rf %{buildroot}%{_datadir}/gradle-local
rm -rf %{buildroot}%{_mandir}/man7/gradle_build.7
%if %{without ivy_local}
rm -rf %{buildroot}%{_sysconfdir}/ivy
rm -rf %{buildroot}%{_sysconfdir}/ant.d
%endif

%if %{with maven_local}
mv %{buildroot}%{_libdir}/rpm/macros.d/macros.xmvn{,.%{?scl}}
mkdir -p %{buildroot}%{_datadir}/xmvn/conf/
cp -p %{SOURCE8} %{buildroot}%{_datadir}/xmvn/conf/toolchains.xml-openjdk8
cp -p %{SOURCE11} %{buildroot}%{_datadir}/xmvn/conf/toolchains.xml-openjdk11
cp -p %{SOURCE17} %{buildroot}%{_datadir}/xmvn/conf/toolchains.xml-openjdk17
%endif


%if 0
install -p -m 644 %{SOURCE3} %{buildroot}%{_sysconfdir}/java/javapackages-config.json
%endif

%if !0%{?rhel}
%check
#./check
%endif

%files -f files-tools

%files -n %{?scl_prefix}javapackages-filesystem -f files-filesystem

%files -n %{?scl_prefix}javapackages-generators -f files-generators

%files -n %{?scl_prefix}javapackages-local -f files-local

%if %{with maven_local}
%files -n %{?scl_prefix}maven-local
%endif

%if %{with ivy_local}
%files -n %{?scl_prefix}ivy-local -f files-ivy
%endif

%if %{with maven_local}
%files -n %{?scl_prefix}maven-local-openjdk8
%dir %{_datadir}/xmvn/conf
%{_datadir}/xmvn/conf/toolchains.xml-openjdk8

%files -n %{?scl_prefix}maven-local-openjdk11
%dir %{_datadir}/xmvn/conf
%{_datadir}/xmvn/conf/toolchains.xml-openjdk11

%files -n %{?scl_prefix}maven-local-openjdk17
%dir %{_datadir}/xmvn/conf
%{_datadir}/xmvn/conf/toolchains.xml-openjdk17
%endif

%files -n %{?scl_prefix}%{python_prefix}-javapackages -f files-python
%license LICENSE

%changelog
* Tue Jun 14 2022 Permaine Cheung <pcheung@redhat.com> - 6.0.0-6
- Enable scl in install section

* Mon Jun 13 2022 Permaine Cheung <pcheung@redhat.com> - 6.0.0-5
- SCL fixes

* Thu May 19 2022 Permaine Cheung <pcheung@redhat.com> - 6.0.0-4
- Rebuild

* Thu May 19 2022 Permaine Cheung <pcheung@redhat.com> - 6.0.0-3
- Do not R: headless jdk

* Thu May 19 2022 Permaine Cheung <pcheung@redhat.com> - 6.0.0-2
- Fix rpmmacrodir

* Fri Apr 29 2022 Permaine Cheung <pcheung@redhat.com> - 6.0.0-1
- EAP 8 build
